/*
Compiler: BC++ 3.1,

Compile mode: large

Project: CISR.C
         ..\..\Lib\8000A.Lib
Explain: (1) Show how to read data with COM Port ISR function.

Hordware: IP-8000 MiniOS7 controller
*/
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<dos.h>
#include<string.h>
#include"..\..\lib\8000a.h"
int QUIT=0;
int DI_COM_ISR(unsigned char data);
void main(void)
{
	int inumber,i2;
	char string[80];
	int inputData;
	int no;
	InitLib();
	/* Install COM 3 */
	InstallCom_3(115200,8,0,1);
	/* Install COM 3 ISR callback function */
	InstallComInputData_3(&DI_COM_ISR);
	while(!QUIT){
		/* Wait until user input ESC key */
		Delay(100);
	}
	RestoreCom_3();
}
int DI_COM_ISR(unsigned char data)
{
	switch(data){
		case 27:{
			printCom(3,"Exit \n");
			QUIT=1;
			break;
		}
		default:{
			printCom(3,"%c",data);
			break;
		}
	}
	return 0;
}