#include <stdio.h>
#include "..\..\lib\8000a.h"
#include "..\..\lib\DCON_FUN.h"
#include <stdlib.h>
#include <string.h>


void main()
{
    int iRet,iAddress,iTotalChannel,iComPort,iCheckSum,iTimeOut,iSlot;
    int iValue,iSingleChannel,iDataFormat,iAO_TotalCh;
    float fValue,fRead_value;
    unsigned char cTemp[10],sTemp[5];
    unsigned long lBaudrate; 
    
    InitLib();
    //AddCom2Fun();
    
    Print("Please Input Comport Number :");
    LineInput(cTemp,10);               
    sscanf(cTemp,"%d",&iComPort);  
        
    Print("Please Input module's address(0~256) :");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iAddress);
    
    Print("Please Input Baudrate :");
    LineInput(cTemp,10);                  
    sscanf(cTemp,"%lu",&lBaudrate);         
    
    Print("*******************************************************************************\n\r");
    Print("If the master uses com0 or connect to I-8000, please input slot's number(0~7).\n\r");
    Print("Else input -1 :");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iSlot);
    Print("*******************************************************************************\n\r");
        
    Print("Please Input Total AO Channel Number :");
    LineInput(cTemp,10);            
    sscanf(cTemp,"%d",&iAO_TotalCh);  
    
    Print("Please Select Checksum(0:Disable or 1:Enable) :");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iCheckSum);
    
    Print("Please Input TimeOut :");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iTimeOut);
    
    InstallCom(iComPort,lBaudrate,8,0,1);
    
    for(;;)
    {
        if(iAO_TotalCh==1)
        {
             
        }
        else
        {
            Print("Please Select a single Channel Number :");
            LineInput(cTemp,10);            
            sscanf(cTemp,"%d",&iSingleChannel); 
        }
        
        Print("Please Input value(float)=");
        LineInput(cTemp,10);            
        sscanf(cTemp,"%f",&fValue);                 
        
        iRet=DCON_Write_AO(iComPort,iAddress,iSlot,iSingleChannel,iAO_TotalCh,
                            fValue,iCheckSum,iTimeOut);
        if(iRet==NoError)
        {
            Print("Output successful!!\n\r");
            iRet=DCON_Read_AO(iComPort,iAddress,iSlot,iSingleChannel,iAO_TotalCh,iCheckSum,
                                iTimeOut,&fRead_value);
            if(iRet==NoError)
            {
                Print("Output value=%f\n\r",fRead_value);
            }
            else
                Print("Reading Analog Output error!! Error Code %d\n\r",iRet);
        }
        else
            Print("Output error!! Error Code %d\n\r",iRet);                    
    
        Puts("\n\rPress 'q' or 'Q' to quit, other key to continue....");
        sTemp[0]=Getch();
        if(sTemp[0]=='q' || sTemp[0]=='Q')
            return;
        Puts("\n\r\n\r");
    
    }
}
