#include <stdio.h>
#include "..\..\lib\8000a.h"
#include "..\..\lib\DCON_FUN.h"
#include <stdlib.h>
#include <string.h>

void main()
{
    int iAddress,iComPort,iCheckSum,iTimeOut,iSlot,iTotalChannel;
    int iRet,iDI_TotalCh,iDO_TotalCh,i;
    char sTemp[10];
    
    unsigned long lDI_Value,lDO_Value;
     
    unsigned char cTemp[10],cDI_BitValue[32],cDO_BitValue[32];
    unsigned long lBaudrate; 
    
    InitLib();
    AddCom2Fun();
    
    Print("Please Input Comport Number:");
    LineInput(cTemp,10);               
    sscanf(cTemp,"%d",&iComPort);  
        
    Print("Please Input module's address(0~256) =");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iAddress);
    
    Print("Please Input Baudrate:");
    LineInput(cTemp,10);                  
    sscanf(cTemp,"%lu",&lBaudrate);         
    
    Print("Please Input slot's number(0~7). If the slave module is not I-8000, plese input -1.");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iSlot);
    
    Print("Please Input DO ToTal Channel:");
    LineInput(cTemp,10);            
    sscanf(cTemp,"%d",&iDO_TotalCh);  
    
    Print("Please Input DI ToTal Channel:");
    LineInput(cTemp,10);            
    sscanf(cTemp,"%d",&iDI_TotalCh);  
    
    Print("Please Select Checksum(0:Disable or 1:Enable):");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iCheckSum);
    
    Print("Please Input TimeOut:");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iTimeOut);
    
    InstallCom(iComPort,lBaudrate,8,0,1);

    for(;;)
    {
        iRet=DCON_Read_DIO(iComPort,iAddress,iSlot,iDI_TotalCh,iDO_TotalCh,
                            iCheckSum,iTimeOut,&lDI_Value,&lDO_Value,&cDI_BitValue,
                            &cDO_BitValue);
        if(iRet==0)
        {
            Print(" DI==%lX,DO==%lX\n\r",lDI_Value,lDO_Value);
            
            Print("\n\rDI(BitN ~ Bit0): ");
            for(i=iDI_TotalCh-1;i>=0;i--)
                 Print("%d",cDI_BitValue[i]);
          
            Print("\n\rDO(BitN ~ Bit0): ");
            for(i=iDO_TotalCh-1;i>=0;i--)
                  Print("%d",cDO_BitValue[i]);
        }
        else
        {
            Print("Error code %d\n\r",iRet);            
        }
        
        Puts("\n\rPress 'q' or 'Q' to quit, other key to continue....");
        sTemp[0]=Getch();
        if(sTemp[0]=='q' || sTemp[0]=='Q')
            return;
        Puts("\n\r\n\r");
    
    }
}
