#include <stdio.h>
#include "..\..\lib\8000a.h"
#include "..\..\lib\DCON_FUN.h"
#include <stdlib.h>
#include <string.h>


void main()
{
    int iRet,iAddress,iTotalChannel,iComPort,iCheckSum,iTimeOut,iSlot;
    int iValue;
    unsigned char cTemp[10],sTemp[5];
    unsigned long lBaudrate; 
    unsigned long lDO_Value;
    
    InitLib();
    //AddCom2Fun();
    
    Print("Please Input Comport Number:");
    LineInput(cTemp,10);               
    sscanf(cTemp,"%d",&iComPort);  
        
    Print("Please Input module's address(0~256) =");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iAddress);
    
    Print("Please Input Baudrate:");
    LineInput(cTemp,10);                  
    sscanf(cTemp,"%lu",&lBaudrate);         
    
    Print("Please Input slot's number(0~7). If the slave module is not I-8000, plese input -1.");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iSlot);
    
    Print("Please Input Total DO Channel Number =");
    LineInput(cTemp,10);            
    sscanf(cTemp,"%d",&iTotalChannel);  
    
    Print("Please Select Checksum(0:Disable or 1:Enable):");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iCheckSum);
    
    Print("Please Input TimeOut:");
    LineInput(cTemp,10);
    sscanf(cTemp,"%d",&iTimeOut);
    
    InstallCom(iComPort,lBaudrate,8,0,1);    
    
    for(;;)
    {
        Print("Please Input DO Data(Hex) = ");
        LineInput(cTemp,10); 
        sscanf(cTemp,"%08lX",&lDO_Value);
    
        iRet=DCON_Write_DO(iComPort,iAddress,iSlot,iTotalChannel,lDO_Value,iCheckSum,iTimeOut);
        if(iRet==NoError)
            Print("Output success!!\n\r");
        else
            Print("Output error!!, Error code %d\n\r",iRet);            
        
        Puts("\n\rPress 'q' or 'Q' to quit, other key to continue....");
        sTemp[0]=Getch();
        if(sTemp[0]=='q' || sTemp[0]=='Q')
            return;
        Puts("\n\r\n\r");
    }
}
